package jugs.javafx.d_charts;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.geometry.Side;
import javafx.scene.Scene;
import javafx.scene.chart.PieChart;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise2_PieChartExample extends Application {

	public static void main(String[] args) {
		Application.launch(args);
	}

	@Override
	public void start(final Stage initialStage) throws Exception {

		initialStage.setTitle("PieChartExample");

		final PieChart pieChart = new PieChart();
		pieChart.setData(getPieChartData());
		
		// Position of Legend
		pieChart.setLabelLineLength(10);
		pieChart.setLegendSide(Side.LEFT);
				
		final StackPane container = new StackPane();
		container.getChildren().addAll(pieChart);
        
		initialStage.setScene(new Scene(container, 500, 400));
		initialStage.show();
	}

	public static ObservableList<PieChart.Data> getPieChartData()
	{
		final ObservableList<PieChart.Data> pieChartData = FXCollections.observableArrayList();
		
		pieChartData.add(new PieChart.Data("JavaFX", 24.0));
		pieChartData.add(new PieChart.Data("Swing", 54.0));
		pieChartData.add(new PieChart.Data("AWT", 5.0));
		pieChartData.add(new PieChart.Data("GWT", 6.0));
		pieChartData.add(new PieChart.Data("SWT", 11.0));
		
		return pieChartData;
	}
}
